package polyglot.ext.ibex.extension;

import polyglot.ast.*;
import polyglot.ext.jl.ast.JL_c;
import polyglot.ext.ibex.types.*;
import polyglot.types.*;
import polyglot.visit.*;
import polyglot.util.*;
import java.util.*;

/**
 * TODO: Documentation
 */
public class IbexClassBodyDel extends JL_c implements JL {
    public Node typeCheck(TypeChecker tc) throws SemanticException {
        IbexTypeSystem ts = (IbexTypeSystem) tc.typeSystem();
        Context c = tc.context();

        ClassBody n = (ClassBody) node();

        ParserType pt = (ParserType) c.currentClass();

        if (! pt.isParser()) {
            return super.typeCheck(tc);
        }

        // check nonterminal conformance
        // check terminal conformance
        // check for duplicate nonterminals
        // check for duplicate terminals

        // check that there is a start nonterminal
        boolean hasStart = false;

        for (Iterator i = pt.allNonterminals().iterator(); i.hasNext(); ) {
            Nonterminal s = (Nonterminal) i.next();
            if (s.isStart()) {
                hasStart = true;
            }
        }

        if (! hasStart) {
            throw new SemanticException("Parser must have a start symbol.",
                pt.position());
        }

        // check that the class implements ibex.runtime.Parser
        if (! pt.isSubtype(ts.runtimeParserType())) {
            throw new SemanticException("Parser must be implement interface \"" +
                                        ts.runtimeParserType() + "\".",
                                        pt.position());
        }

        return super.typeCheck(tc);
    }
}
