package polyglot.ext.ibex.types;

import polyglot.types.*;
import polyglot.ext.jl.types.*;
import polyglot.util.*;
import java.util.*;

public class RhsMerge_c extends TypeObject_c implements RhsMerge {
    RhsCase rhs1;
    RhsCase rhs2;

    public RhsMerge_c(IbexTypeSystem ts, Position pos, RhsCase rhs1, RhsCase rhs2) {
        super(ts, pos);
        this.rhs1 = rhs1;
        this.rhs2 = rhs2;
    }

    public RhsCase rhs1() {
        return rhs1;
    }

    public RhsCase rhs2() {
        return rhs2;
    }

    public boolean isCanonical() {
        return true;
    }

    public boolean matches(Rhs rhs) {
        if (rhs instanceof RhsMerge) {
            RhsMerge m = (RhsMerge) rhs;
            return (m.rhs1().matches(rhs1) && m.rhs2().matches(rhs2))
                || (m.rhs1().matches(rhs2) && m.rhs2().matches(rhs1));
        }
        return false;
    }

    public String actionMethodName(Nonterminal lhs) {
        String methodName = "merge$" + lhs.name();
        for (Iterator j = rhs1.elements().iterator(); j.hasNext(); ) {
            Symbol s = (Symbol) j.next();
            methodName += "$" + s.name();
        }
        methodName += "$";
        for (Iterator j = rhs2.elements().iterator(); j.hasNext(); ) {
            Symbol s = (Symbol) j.next();
            methodName += "$" + s.name();
        }
        return methodName;
    }

    public List actionMethodFormalTypes() {
        List l = new ArrayList();
        l.addAll(rhs1.actionMethodFormalTypes());
        l.addAll(rhs2.actionMethodFormalTypes());
        return l;
    }

    public String toString() {
        return rhs1 + " & " + rhs2;
    }
}
