package polyglot.ext.j0.ast;

import polyglot.ext.jl.ast.*;
import polyglot.types.*;
import polyglot.ast.*;
import polyglot.util.*;
import polyglot.ext.j0.types.*;
import polyglot.visit.*;

import java.util.*;

public class J0Call_c extends Call_c implements Call {

    //private J0TypeSystem jts;

    public J0Call_c(Position pos, Receiver target, String name, List arguments) {
	super(pos, target, name, arguments);
    }

    /** Set the method instance of the call. */
    public Call methodInstance(MethodInstance mi) {
	J0Call_c n = (J0Call_c) copy();
	n.mi = mi;
	J0MethodInstance nmi = (J0MethodInstance)n.mi;

	if (nmi.isImportedStatic()) {
	    n.name = nmi.importedStaticQualifiedName();
	}

	return n;
    }
 
    protected Node typeCheckNullTarget(TypeChecker tc, List argTypes) throws SemanticException {
        Context c = tc.context();

        J0MethodInstance mi =  (J0MethodInstance)c.findMethod(this.name, argTypes);

	J0Call_c call = (J0Call_c)super.typeCheckNullTarget(tc, argTypes);

	return call.methodInstance(mi);
    }
}
