package polyglot.ext.polyj.parse;

import polyglot.ext.polyj.ast.*;

import polyglot.ast.*;
import polyglot.visit.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.parse.*;

import java.util.*;

/**
 * A TypeSub is a Sub whose syntax makes it unambiguously a type
 * (an unambiguous array type or a primitive type).
 */
public class TypeSub extends AbstractSub {
    TypeNode tn;
    
    public TypeSub(BaseParser parser, Position pos, TypeNode tn) {
        super(parser, pos);
        this.tn = tn;
    }
    
    public TypeNode toType() {
        return tn;
    }
    
    public Parse prepend(Parse base) throws Exception {
        List l = new TypedList(new ArrayList(1), Sub.class, false);
        l.add(this);
        return new Inst(parser, base.pos, base.toClassType(), l);
    }
    
    public ParamNode toParam() throws Exception {
        return nf.TypeParam(pos, tn);    
    }
}
