package polyglot.ext.pure.ast;

import polyglot.ast.*;
import polyglot.ext.pure.extension.*;
import polyglot.ext.jl.ast.*;
import polyglot.types.Flags;
import polyglot.types.Package;
import polyglot.types.Type;
import polyglot.types.Qualifier;
import polyglot.util.*;
import java.util.*;

/**
 * NodeFactory for pure extension.
 */
public class PureNodeFactory_c extends ExtNodeFactory_c implements PureNodeFactory {
    public PureNodeFactory_c() {
        super(new NodeFactory_c());
    }

    public Assign extAssign(Assign n) {
        return (Assign) super.extAssign(n).del(new PureAssignExt());
    }

    public New extNew(New n) {
        return (New) super.extNew(n).del(new PureNewExt());
    }

    public ConstructorCall extConstructorCall(ConstructorCall n) {
        return (ConstructorCall) super.extConstructorCall(n).del(new PureConstructorCallExt());
    }

    public Call extCall(Call n) {
        return (Call) super.extCall(n).del(new PureCallExt());
    }

    public ConstructorDecl extConstructorDecl(ConstructorDecl n) {
        return (ConstructorDecl) super.extConstructorDecl(n).del(new PureConstructorDeclExt());
    }

    public MethodDecl extMethodDecl(MethodDecl n) {
        return (MethodDecl) super.extMethodDecl(n).del(new PureMethodDeclExt());
    }
}
